-------------------------------------------------------------------------------
-- Concurrent Haskell Stepper
--   Stepper Module
--   
-------------------------------------------------------------------------------

module Stepper 
  (
  startCheck,
  CodePosition(..),
  module CHS.StepperMain,
  module CHS.StepperChan,
  module CHS.StepperMVar,
  module CHS.StepperQSem,
  module CHS.StepperQSemN,
  module CHS.StepperSampleVar,
  module CHS.StepperIO
  )
  where


-------------------------------------------------------------------------------
-- IMPORTS
-------------------------------------------------------------------------------

import Prelude hiding ( IO )
import qualified Prelude ( IO )
import qualified Control.Concurrent as C

import CHS.StepperMain
import CHS.StepperChan
import CHS.StepperMVar
import CHS.StepperQSem
import CHS.StepperQSemN
import CHS.StepperSampleVar
import CHS.StepperIO
import CHS.BaseTypes
import CHS.CheckMain
import CHS.StepMain


-------------------------------------------------------------------------------
-- TYPES
-------------------------------------------------------------------------------

-------------------------------------------------------------------------------
-- FUNCTIONS
-------------------------------------------------------------------------------

startCheck :: IO () -> Prelude.IO ()
startCheck io = do 
  threadId <- C.forkIO (executeIO io)
  loopCheck [(threadId,io)] Nothing